unit AutomationClient2MainFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFrmClient1 = class(TForm)
    Timer1: TTimer;
    Label1: TLabel;
    btnToggleVisible: TButton;
    btnQuitServer: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnToggleVisibleClick(Sender: TObject);
    procedure btnQuitServerClick(Sender: TObject);
  private
    Server: Variant;
  end;

var
  FrmClient1: TFrmClient1;

implementation

uses
  ComObj;

{$R *.DFM}

procedure TFrmClient1.FormCreate(Sender: TObject);
begin
  try
    Server := GetActiveOleObject('AutomationServer2.Clock');
  except
    on EOleSysError do
      Server := CreateOleObject('AutomationServer2.Clock')
  end;
  Timer1.Enabled := True
end;

procedure TFrmClient1.Timer1Timer(Sender: TObject);
begin
  try
    Label1.Caption := DateTimeToStr(Server.DateAndTime)
  except
    on E: Exception do
    begin
      Label1.Caption := Format('%s: %s', [E.ClassName, E.Message]);
      TTimer(Sender).Enabled := False;
      btnToggleVisible.Enabled := False;
      btnQuitServer.Enabled := False
    end
  end
end;

procedure TFrmClient1.btnToggleVisibleClick(Sender: TObject);
begin
  Server.Visible := not Server.Visible
end;

procedure TFrmClient1.btnQuitServerClick(Sender: TObject);
begin
  Server.Quit
end;

end.
